%{
/* $Id: preparser-parser.y,v 1.5 2001/02/24 00:00:59 davidg Exp $
Copyright (C) 1999 Jukka Zitting <jukka.zitting@iki.fi>
Copyright (C) 2000 The Midgard Project ry
Copyright (C) 2000 Emile Heyns, Aurora SA <emile@iris-advies.com>

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published
by the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
  /*#include "mgd_wild.h"*/
  /*#define PARSER_DEBUG*/
  
  #include <stdio.h>
  #include <malloc.h>
  #include <strings.h>
  #include "php_midgard.h"
  #include "midgard/midgard.h"
  #include "mgd_preparser.h"
%}

%union {
//  char string[256];
  GByteArray *gstring;
}

%token <gstring> STRING
%token MGD_TMPL
%token MGD_TMPLE
%token MGD_VAR
%token MGD_VARE
%token MGD_SNIP
%token MGD_SNIPE
%token MGD_EVAL
%token MGD_INCLUDE

%%

input:
 | input instructions
;

instructions:
 | MGD_TMPL STRING MGD_TMPLE {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed elem: ");
   mgd_append_output_buffer_data($2);
#endif
   mgd_append_output_buffer_const("<? mgd_eval(\"?>\".mgd_template(\"");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const("\"). \"<?\", \"");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const("\"); ?>");
   mgd_free_buffer($2);
 }
 | MGD_VAR MGD_VARE {
   yyerror("parse error, missing variable");
 }
 | MGD_VAR STRING MGD_VARE {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed var 1: ");
   mgd_append_output_buffer_data($2);
#endif
   mgd_append_output_buffer_const("<? echo mgd_variable(\"");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const("\"); ?>");
   mgd_free_buffer($2);
 }
 | MGD_VAR STRING ':' MGD_VARE {
   yyerror("parse error, missing formatter");
 }
 | MGD_VAR STRING ':' STRING MGD_VARE {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed var 2: ");
   mgd_append_output_buffer_data($2);
   if( (($4)->data[0] == 'h') || (($4)->data[0] == 'H') ||
       (($4)->data[0] == 'f') || (($4)->data[0] == 'F') ||
       (($4)->data[0] == 'p') || (($4)->data[0] == 'u') ) {
#endif
   if(($4)->data[0] == 'p') {
     mgd_append_output_buffer_const("<? mgd_eval(\"?>\".$");
     mgd_append_output_buffer_data($2);
     mgd_append_output_buffer_const(".\"<?\",\'");
     mgd_append_output_buffer_data($2);
     mgd_append_output_buffer_const("\'); ?>");
   } else if(($4)->data[0] == 'i') {
     mgd_append_output_buffer_const("<? ");
     g_byte_array_append(($2), "", 1);
     mgd_append_output_buffer(php_midgard_variable(NULL, ($2)->data, NULL, "i"));
     mgd_append_output_buffer_const(" ?>");
   } else {
     mgd_append_output_buffer_const("<? echo mgd_variable(\"");
     mgd_append_output_buffer_data($2);
     mgd_append_output_buffer_const("\",\"");
     mgd_append_output_buffer_data($4);
     mgd_append_output_buffer_const("\"); ?>");
   }
#ifdef PARSER_DEBUG
   } else {
     yyerror("parse error, wrong formatter");
   }
#endif
   mgd_free_buffer($2);
   mgd_free_buffer($4);
 }
 | MGD_VAR STRING '.' STRING MGD_VARE {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed var 3: ");
   mgd_append_output_buffer_data($2);
#endif
   mgd_append_output_buffer_const("<? echo mgd_variable(\"");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const("\",\"");
   mgd_append_output_buffer_data($4);
   mgd_append_output_buffer_const("\",\"\"); ?>");
   mgd_free_buffer($2);
   mgd_free_buffer($4);
 }
 | MGD_VAR STRING '.' STRING ':' STRING MGD_VARE {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed var 4: ");
   mgd_append_output_buffer_data($2);
#endif
   if(($6)->data[0] == 'p') {
     mgd_append_output_buffer_const("<? mgd_eval(\"?>\".$");
     mgd_append_output_buffer_data($2);
     mgd_append_output_buffer_const("->");
     mgd_append_output_buffer_data($4);
/*
     mgd_append_output_buffer_const(".\"<?\",'$");
     mgd_append_output_buffer_data($2);
     mgd_append_output_buffer_const("->");
     mgd_append_output_buffer_data($4);
     mgd_append_output_buffer_const("'); ?>");
*/
     mgd_append_output_buffer_const(".\"<?\"); ?>");
   } else if(($6)->data[0] == 'i') {
     mgd_append_output_buffer_const("<? ");
     g_byte_array_append(($2), "", 1);
     g_byte_array_append(($4), "", 1);
     mgd_append_output_buffer(php_midgard_variable(NULL, ($2)->data, ($4)->data, "i"));
     mgd_append_output_buffer_const(" ?>");
   } else {
     mgd_append_output_buffer_const("<? echo mgd_variable(\"");
     mgd_append_output_buffer_data($2);
     mgd_append_output_buffer_const("\",\"");
     mgd_append_output_buffer_data($4);
     mgd_append_output_buffer_const("\",\"");
     mgd_append_output_buffer_data($6);
     mgd_append_output_buffer_const("\"); ?>");
   }
   mgd_free_buffer($2);
   mgd_free_buffer($4);
   mgd_free_buffer($6);
 }
 | MGD_SNIP STRING {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed snippet: ");
   mgd_append_output_buffer_data($2);
#endif
   mgd_append_output_buffer_const("mgd_eval(\"?>\".mgd_snippet(");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const(").\"<?\",\"snippet://\".");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const(")");
   mgd_free_buffer($2);
 }
 | MGD_EVAL STRING {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed eval: ");
   mgd_append_output_buffer_data($2);
#endif
   mgd_append_output_buffer_const("mgd_eval(");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const(")");
   mgd_free_buffer($2);
 }
 | MGD_INCLUDE STRING {
#ifdef PARSER_DEBUG
   mgd_append_output_buffer_const("parsed include: ");
   mgd_append_output_buffer_data($2);
#endif
   mgd_append_output_buffer_const("$midgard->pp_tmp=\"?>\"."
											"implode(\"\\n\",file(");
   mgd_append_output_buffer_data($2);
   mgd_append_output_buffer_const(")).\"<?\";mgd_eval($midgard->pp_tmp);");
   mgd_free_buffer($2);
 }
;

%%

/* TODO: work on the errors */

//extern FILE *mgdin;

/*
int main(void)
{
  do {
    yyparse();
  } while (!feof(mgdin));

  return 0;
}
*/

void yyerror(char *s)
{
    char *temp = g_strdup_printf("ERROR: %s\n", s);
    mgd_append_output_buffer(temp);
    g_free(temp);
}
